package com.sun.bigbrother.Classifier;

import com.sun.bigbrother.javanet.ClassifierFactory;
import com.sun.bigbrother.javanet.Classifier;
import com.enigmastation.classifier.FisherClassifier;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.FileInputStream;

/**
 * User: nachi
 * Date: Jul 2, 2009
 * Time: 12:47:02 AM
 */
public class ClassifierFactoryImpl implements ClassifierFactory {
    public Classifier create(String projectName) throws IOException {
        FisherClassifier fc = load(projectName);

        if (projectName.equals("glassfish"))
            return new ClassifierImpl(fc, 0.5); // TODO: train the threshold, instead of hard  coding it.
        else
            return new ClassifierImpl(fc,-999);

    }

    private FisherClassifier load(String projectName) throws IOException {
        ObjectInputStream in = null;
        try {
            in = new ObjectInputStream(new FileInputStream(projectName+".ser"));
            return (FisherClassifier) in.readObject();
        } catch (ClassNotFoundException e) {
            throw (Error)new NoClassDefFoundError(e.getMessage()).initCause(e);
        } finally {
            if (in != null)
                in.close();
        }
    }

}
