package com.sun.bigbrother.Classifier;

import com.enigmastation.classifier.ClassifierProbability;
import com.enigmastation.classifier.FisherClassifier;
import com.sun.bigbrother.javanet.Classifier;

/**
 * User: nachi
 * Date: Jul 2, 2009
 * Time: 12:36:09 AM
 */
final class ClassifierImpl implements Classifier{
    private final FisherClassifier fc;
    private final double threshold;

    public ClassifierImpl(FisherClassifier fc, double threshold) {
        this.fc = fc;
        this.threshold = threshold;
    }

    public String predict(String summary, String comment) {
        String description = summary + comment;
        ClassifierProbability[] probabilityArr = fc.getProbabilities(description);
        fc.normalizeProbabilities(probabilityArr);
        double classifierConfidence = Math.log(probabilityArr[0].getScore()/probabilityArr[1].getScore());
        if (classifierConfidence > threshold) {
           return probabilityArr[0].getCategory();
       } else {
           return null;
       }
    }
}
